int block = 0;
int block_size = 256;
int block_number = 2;


/*float two_pi_slice = TWO_PI/(block_size*block_number);
 
 void makeOscil() {
 block_size = 512;
 block_number = 1;
 Lasersegment oscil;
 oscil = new Lasersegment();
 
 float pi_crumb = two_pi_slice*block_size*block;
 
 if (block == block_number) { 
 block = 0;
 }
 else {
 for (int i = 0; i < block_size; i++) {
 oscil.addLpoint(new Laserpoint(cos(t+8.01*pi_crumb)*150,sin(t+8*pi_crumb)*(sin(6*pi_crumb)*150),sin(0.5*pi_crumb)*sin(t+8*pi_crumb)*sin(6*pi_crumb)*150,i/512.0,1.0,1.0));
 pi_crumb+=two_pi_slice;
 }
 
 if (current.segmentcount == block) current.addLsegment(oscil);
 else current.updateLsegment(block,oscil);
 
 // block++;    
 t+=0.05;
 }
 
 }*/

void makeCircle() {
  Lasersegment circle;
  circle = new Lasersegment();
  float pi_slice= TWO_PI/(block_size*block_number);
  float pi_crumb = pi_slice*block_size*block;
  if (block == block_number) { 
    block = 0;
  } 
  else {
    for (int i = 0; i < block_size; i++) {
      circle.addLpoint(new Laserpoint(cos(pi_crumb)*250,sin(pi_crumb)*250,0,0,0,sin(pi_crumb)));
      pi_crumb+=pi_slice;
    }
    if (current.segmentcount == block) current.addLsegment(circle);
    else current.updateLsegment(block,circle);
    block++;
  }
}

void makeSphere(int turns) {
  Lasersegment lsphere;
  colorMode(HSB,1.0);
  lsphere = new Lasersegment();
  float pi_slice= TWO_PI/(block_size*block_number);
  float pi_crumb = pi_slice*block_size*block;
  float depth_slice = 200.0/(block_size*block_number);
  float depth_crumb = -100+depth_slice*block_size*block;
  color pointcolor;
  if (block == block_number) { 
    block = 0;
    //lsphere = new Lasersegment();
  }
  else {
    for (int i = 0; i < block_size; i++) {
      //pointcolor = color(sin(pi_crumb/4),1,1);
      pointcolor=color(1,0,1);
      lsphere.addLpoint(new Laserpoint(cos(turns*pi_crumb)*sin(pi_crumb/2)*100,sin(turns*pi_crumb)*sin(pi_crumb/2)*100,depth_crumb,red(pointcolor),green(pointcolor),blue(pointcolor)));
      pi_crumb+=pi_slice;
      depth_crumb+=depth_slice;
    }
    if (current.segmentcount == block) current.addLsegment(lsphere);
    else current.updateLsegment(block,lsphere);
    block++;
  }   
  colorMode(RGB,1.0);
}


void mouseBeam() {
  Lasersegment lsphere;
  lsphere = new Lasersegment();
  for (int i = 0; i < 512; i++) {
    lsphere.addLpoint(new Laserpoint(mouseX-250,mouseY-250,0,1,1,1));
  }
  current.updateLsegment(0,lsphere);
}



void rubberLine() {
  Lasersegment lline;
  lline = new Lasersegment();
  int cpx, cpy;
  float init_x = -250, init_y = 0, t, p2y = 0, p2x = 250;
  cpx = mouseX-250;
  cpy = mouseY-250;
  int steps = 512;
  for (int i = 0; i < steps; i++) {
    t = (float) i/steps;
    float x = init_x*q3(t) + cpx*q2(t) + p2x*q1(t);
    float y = init_y*q3(t) + cpy*q2(t) + p2y*q1(t);
    lline.addLpoint(new Laserpoint(x,y,0,1,1,1));
  }
  current.updateLsegment(0,lline);
}



void makeRose() {
  float pi_slice= 4*TWO_PI/256;
  float rose_k = 3.0/4;
  float pi_crumb = 0;
  Lasersegment oscil;
  oscil = new Lasersegment();
  for (int i = 0; i < 256; i++) {
    oscil.addLpoint(new Laserpoint(cos(rose_k*pi_crumb)*cos(pi_crumb)*150, cos(rose_k*pi_crumb)*sin(pi_crumb)*150,0,1,1,1));
    pi_crumb+=pi_slice;
  }
  //t+=0.1;
  current.updateLsegment(0,oscil);
}

void liquidWave() {
  Lasersegment wave;
  wave = new Lasersegment();
  float pi_slice= TWO_PI/512;
  float pi_crumb = 0;
  float depth_crumb = 500.0/512;
  float d = -250;
  for (int i = 0; i < 512; i++) {
    wave.addLpoint(new Laserpoint(d, sin(8*pi_crumb)*10,cos(8*pi_crumb)*10,1,1,1));
    pi_crumb+=pi_slice;
    d+=depth_crumb;
  }
  //t+=0.1;
  current.updateLsegment(0,wave);
  x_rotval = 0.1;
}

class laWiggles implements Lasershape {
  Lasersegment wiggle;
  float tparam=0;
  laWiggles() {
    wiggle = new Lasersegment();
    for (int i = 0; i < 500; i++) {
      wiggle.addLpoint(new Laserpoint(0,0,0,random(0,1),random(0,1),random(0,1)));
    }
  }

  Laserframe animate() {
    Laserframe lframe;
    //println(square.pointcount);
    lframe = new Laserframe();

    arrayCopy(wiggle.lpoint, 0, wiggle.lpoint, 1, 499);
    float x = wiggle.lpoint[0].x;
    float y = wiggle.lpoint[0].y;
    float d = (noise(tparam,x/600.0,y/600)-0.5)*800;
    x+=cos(radians(d))*2;
    y+=sin(radians(d))*2;
    wiggle.updateLpoint(0,new Laserpoint(x,y,0,random(0,1),random(0,1),random(0,1)));
    translate(((wiggle.lpoint[100].x-wiggle.lpoint[99].x)+(wiggle.lpoint[50].x-wiggle.lpoint[49].x)+
      (wiggle.lpoint[35].x-wiggle.lpoint[34].x)+(wiggle.lpoint[15].x-wiggle.lpoint[14].x))/4.0,((wiggle.lpoint[50].y-wiggle.lpoint[49].y)+(wiggle.lpoint[30].y-wiggle.lpoint[29].y)+
      (wiggle.lpoint[15].y-wiggle.lpoint[14].y)+(wiggle.lpoint[1].y-wiggle.lpoint[0].y))/4.0);
    tparam+=0.01;
    lframe.addLsegment(wiggle);
    return lframe;
  }
}

class laSquare implements Lasershape {
  Lasersegment square;

  laSquare() {
    square = new Lasersegment();
    int i = 3;
    square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
    square.addLpoint(new Laserpoint(25*i,-25*i,0,0,0,1));
    square.addLpoint(new Laserpoint(25*i,25*i,0,0,0,1));
    square.addLpoint(new Laserpoint(-25*i,25*i,0,0,0,1));
    square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
    square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
  }


  Laserframe animate() {
    Laserframe lframe;
    //println(square.pointcount);
    lframe = new Laserframe();
    lframe.addLsegment(square);
    return lframe;
  }
}

class laSquareTun implements Lasershape {

  Laserframe lframe;

  laSquareTun(int num) {
    lframe = new Laserframe();
    for (int i = 1; i <= num; i++) {
      Lasersegment square = new Lasersegment();
      square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
      square.addLpoint(new Laserpoint(25*i,-25*i,0,0,0,1));
      square.addLpoint(new Laserpoint(25*i,25*i,0,0,0,1));
      square.addLpoint(new Laserpoint(-25*i,25*i,0,0,0,1));
      square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
      square.addLpoint(new Laserpoint(-25*i,-25*i,0,0,0,1));
      lframe.addLsegment(square);
    }
  }


  Laserframe animate() {
    return lframe;
  }
}

class laIlda implements Lasershape {
  Lasersegment ildaseg;
  byte[] ildabytes;
  //Laserframe[] animation;

  laIlda(String filename) {
    // filename = "smiley30k500pts.ild";
    ildabytes = loadBytes(filename);
    ildaseg = new Lasersegment();
    /*int fptr = 0;
     int headerstart;
     int dataentries;
     int format;
     int currentframe;
     int frames;
     animation = new Laserframe[0];
     boolean validheader = false;
     while (fptr < ildabytes.length) {
     if (validheader == false) {
     if (ildabytes[fptr] == 0x49 && ildabytes[fptr+1] == 0x4c && ildabytes[fptr+2] == 0x44 && ildabytes[fptr+3] == 0x41) {
     validheader = true;
     headerstart = fptr;
     format = ildabytes[fptr+8];
     dataentries = (ildabytes[24] << 8) | (ildabytes[25] & 0xFF);
     currentframe = (ildabytes[24] << 8) | (ildabytes[25] & 0xFF);
     frames =  (ildabytes[26] << 8) | (ildabytes[27] & 0xFF);
     fptr+=32;
     }
     }
     */
    int dataentries;
    dataentries = (ildabytes[24] << 8) | (ildabytes[25] & 0xFF);
    for (int i = 0; i < dataentries; i++) {
      float r,g,b;
      float x,y,z;
      x = map( (short)(( ildabytes[32+8*i] << 8 ) + ildabytes[33+8*i]),-32768,32767,-250,250);
      y = map( (short)(( ildabytes[34+8*i] << 8 ) + ildabytes[35+8*i]),32768,-32767,-250,250);
      z = map( (short)(( ildabytes[36+8*i] << 8 ) + ildabytes[37+8*i]),-32768,32767,-250,250);
      // println(i+"/"+dataentries+" - "+hex(ildabytes[39+8*i] & 0xFF));
      r = ILDApal[ildabytes[39+8*i] & 0xFF].r;
      g = ILDApal[ildabytes[39+8*i] & 0xFF].g;
      b = ILDApal[ildabytes[39+8*i] & 0xFF].b;
      if (ildabytes[38+8*i] == 0x40 || ildabytes[38+8*i] == 0x4f) {
        r=g=b=0;
        //println(ildabytes[39+8*i]);
      }
      /*if (ildabytes[38+8*i] == 0x4f || 0x) {
       ildaseg.addLpoint(new Laserpoint(x,y,z,r,g,b));
       animation[framepointer].addLsegment(ildaseg);
       ildaseg = new Lasersegment();
       framepointer++;
       }
       else */      ildaseg.addLpoint(new Laserpoint(x,y,z,r,g,b));
      //println(int(ildabytes[39+8*i]));
    }
  }

  Laserframe animate() {
    Laserframe lframe;
    //println(square.pointcount);
    lframe = new Laserframe();
    lframe.addLsegment(ildaseg);
    return lframe;
  }
}

class laPearls implements Lasershape {
  Laserframe lframe;

  laPearls(int num_pearls) {
    Lasersegment pearls;  
    lframe = new Laserframe();
    if (num_pearls < 1) num_pearls = 1;
    if (num_pearls > 20) num_pearls = 20;
    int points_per_pearl = 768/num_pearls;
    float pi_slice= TWO_PI/(points_per_pearl-1);
    float pearl_slice = TWO_PI/num_pearls;
    float pearl_crumb = 0.0;
    //println(num_pearls);
    for (int j = 0; j < num_pearls; j++) {
      float pi_crumb = 0;
      pearls = new Lasersegment();
      /*        pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));
       pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));
       pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));*/
      for (int k = 0; k < points_per_pearl && k+j*points_per_pearl < 768; k++) {
        pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,1));
        pi_crumb+=pi_slice;
      }
      /*        pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));
       pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));
       pearls.addLpoint(new Laserpoint(cos(pi_crumb)*30+cos(pearl_crumb)*100,sin(pi_crumb)*30+sin(pearl_crumb)*100,0,0,0,0));*/
      pearl_crumb+=pearl_slice;
      lframe.addLsegment(pearls);
    }
  }


  Laserframe animate() {

    //println(square.pointcount);
    //lframe.addLsegment(pearls);
    return lframe;
  }
}

class laLatSphere implements Lasershape {
  Laserframe lframe;

  laLatSphere(int num_rings) {
    Lasersegment ring;  
    lframe = new Laserframe();
    if (num_rings < 2) num_rings = 2;
    if (num_rings > 20) num_rings = 20;
    int points_per_ring = 768/num_rings;
    float pi_slice= TWO_PI/(points_per_ring-2);
    float ring_slice = PI/num_rings;
    float ring_crumb = ring_slice;
    float pi_crumb = 0;
    float depth_crumb = 200.0/num_rings;
    float d = -100;
    for (int j = 0; j < num_rings-1; j++) {
      pi_crumb = 0;
      ring = new Lasersegment();
      for (int k = 0; k < points_per_ring && k+j*points_per_ring < 768; k++) {
        ring.addLpoint( new Laserpoint (cos(pi_crumb)*sin(ring_crumb)*100,d,sin(pi_crumb)*sin(ring_crumb)*100,0,0,1));
        pi_crumb+=pi_slice;
      }
      lframe.addLsegment(ring);
      ring_crumb+=ring_slice;
      d+=depth_crumb;
    }
  }


  Laserframe animate() {

    //println(square.pointcount);
    //lframe.addLsegment(pearls);
    return lframe;
  }
}

class laRipple implements Lasershape {

  Laserframe lframe;
  float pi_slice = TWO_PI/511;
  float pi_crumb = 0.0;
  color pointcolor;
  Lasersegment ripple;
  float radius = 1;
  float noiset = 0;
  int t =1;

  laRipple() {
    noiseDetail(4);
    colorMode(HSB,1.0);
    ripple = new Lasersegment();
    for (int i = 0; i < 512; i++) {
      pointcolor = color(sin(pi_crumb/4),1,1);
      ripple.addLpoint(new Laserpoint(cos(pi_crumb)*(radius/2+noise(cos(pi_crumb)+10,sin(pi_crumb)+10,noiset)*radius),sin(pi_crumb)*(radius/2+noise(cos(pi_crumb)+10,sin(pi_crumb)+10,noiset)*radius),0,red(pointcolor),green(pointcolor),blue(pointcolor)));
      pi_crumb+=pi_slice;
    }

    colorMode(RGB,1.0);
    noiset+=0.01;

    if (t>25) t =1;
    radius=sq(t);
    t++;
  }

  Laserframe animate() {
    pi_crumb = 0.0;
    noiseDetail(4);
    colorMode(HSB,1.0);
    for (int i = 0; i < 512; i++) {
      pointcolor = color(sin(pi_crumb/4),1,1);
      ripple.updateLpoint(i,new Laserpoint(cos(pi_crumb)*(radius/2+noise(cos(pi_crumb)+10,sin(pi_crumb)+10,noiset)*radius),sin(pi_crumb)*(radius/2+noise(cos(pi_crumb)+10,sin(pi_crumb)+10,noiset)*radius),0,red(pointcolor),green(pointcolor),blue(pointcolor)));
      pi_crumb+=pi_slice;
    }

    colorMode(RGB,1.0);
    noiset+=0.01;

    if (t>25) t =1;
    radius=sq(t);
    t++;
    lframe = new Laserframe();
    lframe.addLsegment(ripple);
    return lframe;
  }
}

class laBeam implements Lasershape {
  Laserframe lframe;

  laBeam(float _x, float _y, float _z, float _r, float _g, float _b) {
    lframe = new Laserframe();
    Lasersegment beam = new Lasersegment();

    for (int i = 0; i<256; i++) {
      beam.addLpoint(new Laserpoint(_x,_y,_z,_r,_g,_b));
    }
    lframe.addLsegment(beam);
  }

  Laserframe animate() {
    pushMatrix();
    translate(lframe.lsegment[0].lpoint[0].x,lframe.lsegment[0].lpoint[0].y,lframe.lsegment[0].lpoint[0].z);
    sphere(1);
    popMatrix();
    return lframe;
  }
}

class laStarfield implements Lasershape {
  Laserframe lframe;
  int N = 50;
  class Star {
    float vx;
    float vy;
    float x;
    float y;
  }

  Star[] mystars = new Star[N];

  laStarfield() {
    int dwell = 10;
    lframe = new Laserframe();
    for (int i = 0; i < N; i++) {
      mystars[i] = new Star();
      mystars[i].x = 0;
      mystars[i].y = 0;
      mystars[i].vx = random(-2,2);
      mystars[i].vy = random(-2,2);
      lframe.addLsegment( new Lasersegment(new Laserpoint(0,0,0,1,1,1)));
    }
  }

  Laserframe animate() {
    for (int i = 0; i < N; i++) {
      if (mystars[i].x > 250 || mystars[i].y > 250 || mystars[i].x < -250 || mystars[i].y < -250) {
        mystars[i].x = mystars[i].y = 0;
        mystars[i].vx = random(-2,2);
        mystars[i].vy = random(-2,2);
      }
      else {
        mystars[i].y += mystars[i].vy;
        mystars[i].x += mystars[i].vx;
      }
      lframe.lsegment[i].updateLpoint(0, new Laserpoint(mystars[i].x,mystars[i].y,0,1,1,1));
      pushMatrix();
      translate(lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[0].y,0);
      sphere(1);
      popMatrix();
    }
    return lframe;
  }
} 

class laGravStars implements Lasershape {
  Laserframe lframe;
  int N = 20;
  class Star {
    float vx;
    float vy;
    float x;
    float y;
  }

  Star[] mystars = new Star[N];

  laGravStars() {
    int dwell = 10;
    lframe = new Laserframe();
    for (int i = 0; i < N; i++) {
      mystars[i] = new Star();
      mystars[i].x = random(-50,50);
      mystars[i].y = random(-50,50);
      float gravdist = dist(mystars[i].x,mystars[i].y,0,0)+3;
      if (gravdist < 10) gravdist = 10;
      //mystars[i].vx = 120/sq(gravdist)*sin(mystars[i].x/-250*PI/2.0);
      //mystars[i].vy = 120/sq(gravdist)*sin(mystars[i].y/-250*PI/2.0);
      mystars[i].vx = random(-1.5,1.5);
      mystars[i].vy = random(-1.5,1.5);

      lframe.addLsegment( new Lasersegment(new Laserpoint(mystars[i].x,mystars[i].y,0,1,1,1)));
    }
  }

  Laserframe animate() {
    for (int i = 0; i < N; i++) {
      float gravdist = dist(mystars[i].x,mystars[i].y,0,0)+3;
      if (gravdist < 3) gravdist = 3;
      mystars[i].vx += 150/sq(gravdist)*sin((mystars[i].x)/-250*PI/2.0);
      mystars[i].vy += 150/sq(gravdist)*sin((mystars[i].y)/-250*PI/2.0);

      mystars[i].x += mystars[i].vx;
      mystars[i].y += mystars[i].vy;

      lframe.lsegment[i].updateLpoint(0, new Laserpoint(mystars[i].x,mystars[i].y,0,1,1,1));
      pushMatrix();
      translate(lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[0].y,0);
      sphere(1);
      popMatrix();
    }
    return lframe;
  }
}

class laBoids implements Lasershape {
  Laserframe lframe;
  int N = 20;
  int dwell = 10;

  class PCMass {
    float x;
    float y;
  }

  class PVel {
    float vx;
    float vy;
  }

  class Avoid {
    float x;
    float y;
  }

  class Bound {
    float x;
    float y;
  }

  class Boid {
    float vx;
    float vy;
    float x;
    float y;
    PCMass pc;
    PVel pv;
    Avoid a;
    Bound b;
  }

  Boid[] myboids = new Boid[N];

  laBoids() {

    lframe = new Laserframe();
    for (int i = 0; i < N; i++) {
      Lasersegment boidsegment = new Lasersegment();
      myboids[i] = new Boid();
      myboids[i].x = random(-250,250);
      myboids[i].y = random(-250,250);
      myboids[i].vx = random(-1.5,1.5);
      myboids[i].vy = random(-1.5,1.5);


      for (int k = 0; k < dwell; k++) boidsegment.addLpoint(new Laserpoint(myboids[i].x,myboids[i].y,0,1,1,1));
      lframe.addLsegment(boidsegment);
    }
  }

  PCMass rule1(int boidnum) {
    PCMass _pcmass = new PCMass();
    _pcmass.x = 0;
    _pcmass.y = 0;
    for (int i = 0; i < N; i++) {
      if (i != boidnum) {
        _pcmass.x+=myboids[i].x;
        _pcmass.y+=myboids[i].y;
      }
    }
    _pcmass.x = _pcmass.x/(N-1);
    _pcmass.y = _pcmass.y/(N-1);
    return _pcmass;
  }

  PVel rule2(int boidnum) {
    PVel _pvel = new PVel();
    _pvel.vx = 0;
    _pvel.vy = 0;
    for (int i = 0; i < N; i++) {
      if (i != boidnum) {
        _pvel.vx+=myboids[i].vx;
        _pvel.vy+=myboids[i].vy;
      }
    }
    _pvel.vx = _pvel.vx/(N-1);
    _pvel.vy = _pvel.vy/(N-1);
    return _pvel;
  }

  Avoid rule3(int boidnum) {
    Avoid _avoid = new Avoid();
    _avoid.x = 0;
    _avoid.y = 0;
    for (int i = 0; i < N; i++) {
      if (i != boidnum) {
        if (dist(myboids[i].x, myboids[i].y, myboids[boidnum].x, myboids[boidnum].y) < 15) {
          _avoid.x = _avoid.x - (myboids[i].x - myboids[boidnum].x);
          _avoid.y = _avoid.y - (myboids[i].y - myboids[boidnum].y);
        }
      }
    }
    return _avoid;
  }  

  Bound rule4(int boidnum) {
    Bound _bound = new Bound();
    _bound.x = 0;
    _bound.y = 0;
    if (myboids[boidnum].x > 230 || myboids[boidnum].x < -230) {
      _bound.x = 100*-myboids[boidnum].x/250;
    }
    if (myboids[boidnum].y > 230 || myboids[boidnum].y < -230) {
      _bound.y = 100*-myboids[boidnum].y/250;
    }
    return _bound;
  }

  Laserframe animate() {

    for (int i = 0; i < N; i++) {

      myboids[i].pc = rule1(i);
      myboids[i].pv = rule2(i);
      myboids[i].a = rule3(i);
      myboids[i].b = rule4(i);
      myboids[i].vx += (((myboids[i].pc.x - myboids[i].x)/100)+((myboids[i].pv.vx-myboids[i].vx)/8)+(myboids[i].a.x/4))/10+(myboids[i].b.x/100);
      myboids[i].vy += (((myboids[i].pc.y - myboids[i].y)/100)+((myboids[i].pv.vy-myboids[i].vy)/8)+(myboids[i].a.y/4))/10+(myboids[i].b.y/100);
      colorMode(HSB,1.0);
      color boidcolor = color((atan2(myboids[i].vy,myboids[i].vx)+PI)/TWO_PI,1,1);
      colorMode(RGB,1.0);
      if (myboids[i].vx > 3) myboids[i].vx--;
      if (myboids[i].vy > 3) myboids[i].vy--;
      if (myboids[i].vx < -3) myboids[i].vx++;
      if (myboids[i].vy < -3) myboids[i].vy++;      
      myboids[i].x += myboids[i].vx;
      myboids[i].y += myboids[i].vy;
      for (int k = 0; k < dwell; k++) lframe.lsegment[i].updateLpoint(k, new Laserpoint(myboids[i].x,myboids[i].y,0,red(boidcolor),green(boidcolor),blue(boidcolor)));
      pushMatrix();
      stroke(red(boidcolor),green(boidcolor),blue(boidcolor));
      translate(lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[0].y,0);
      sphere(1);
      popMatrix();
    }

    return lframe;
  }
}

class laText implements Lasershape {
  Laserframe lframe;
  FontOutlineSystem fos;

  laText(String _text) {

    lframe = new Laserframe();
    Lasersegment ltext;
    ltext = new Lasersegment();
    ArrayList path;
    fos = new FontOutlineSystem();
    fos.loadFont("Lucida Bright", 100);
    path = fos.convert(_text, -180, 0);
    for (int i=0, n=path.size(); i<n; i++) {
      FontPoint fp = (FontPoint)path.get(i);
      if (fp.mode == FontPoint.CLOSE) {
        lframe.addLsegment(ltext);
        ltext = new Lasersegment();
      }
      else {
        ltext.addLpoint(new Laserpoint(fp.x,fp.y,0,1,1,1.0));
      }
    }
  }
  Laserframe animate() {
    return lframe;
  }
}

class laDigitalClock implements Lasershape {
  Laserframe lframe;
  FontOutlineSystem fos;
  ArrayList path;
  laDigitalClock() {
    lframe = new Laserframe();
    Lasersegment ltext;
    ltext = new Lasersegment();
    fos = new FontOutlineSystem();
    fos.loadFont("Lucida Bright", 50);
    path = fos.convert(nf(hour(),2)+":"+nf(minute(),2) +":"+nf(second(),2),-180, 0);
    for (int i=0, n=path.size(); i<n; i++) {
      FontPoint fp = (FontPoint)path.get(i);
      if (fp.mode == FontPoint.CLOSE) {
        lframe.addLsegment(ltext);
        ltext = new Lasersegment();
      }
      else {
        ltext.addLpoint(new Laserpoint(fp.x,fp.y,0,1,1,1.0));
      }
    }
  }
  Laserframe animate() {
    Lasersegment ltext;
    ltext = new Lasersegment();
    lframe = new Laserframe();
    path = fos.convert(nf(hour(),2)+":"+nf(minute(),2) +":"+nf(second(),2),-180, 0);
    for (int i=0, n=path.size(); i<n; i++) {
      FontPoint fp = (FontPoint)path.get(i);
      if (fp.mode == FontPoint.CLOSE) {
        lframe.addLsegment(ltext);
        ltext = new Lasersegment();
      }
      else {
        ltext.addLpoint(new Laserpoint(fp.x,fp.y,0,1,1,1.0));
      }
    }
    return lframe;
  }
}

class laHexes implements Lasershape {
  Laserframe lframe;
  float noiseloc;

  laHexes() {
    lframe = new Laserframe();

    for (int i = 0; i < 6; i++) {
      Lasersegment polyseg = new Lasersegment();
      Laserpoint[] j = {
        new Laserpoint(cos(i*PI/3)*75,sin(i*PI/3)*75,0,1,1,1),new Laserpoint(cos((i+1)*PI/3)*75,sin((i+1)*PI/3)*75,0,1,1,1)      };
      polyseg.addLpoint(j);
      lframe.addLsegment(polyseg);
      lframe.lsegment[i].setAnchor(lerp(lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[1].x,0.5),
                                   lerp(lframe.lsegment[i].lpoint[0].y,lframe.lsegment[i].lpoint[1].y,0.5),0);
    }
  }

  Laserframe animate() {
    for (int i = 0; i< lframe.lsegment.length; i++) {
    /*  double[] vals1 = {
        lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[0].y,lframe.lsegment[i].lpoint[0].z      };
      double[] vals2 = {
        lframe.lsegment[i].lpoint[1].x,lframe.lsegment[i].lpoint[1].y,lframe.lsegment[i].lpoint[1].z      };
      double[] tvals = {(double)lerp((float)vals1[0],(float)vals2[0],0.5),
                        (double)lerp((float)vals1[1],(float)vals2[1],0.5),
                        (double)lerp((float)vals1[2],(float)vals2[2],0.5)};
      Matrix A = new Matrix(vals1,3);
      Matrix T = new Matrix(tvals,3);
      A.minusEquals(T);
      Matrix C = B.times(A);
      C.plusEquals(T);
      lframe.lsegment[i].updateLpoint(0,new Laserpoint((float) C.get(0,0),(float)C.get(1,0),(float)C.get(2,0)));
      A = new Matrix(vals2,3);
      A.minusEquals(T);
      C = B.times(A);
      C.plusEquals(T);
      lframe.lsegment[i].updateLpoint(1,new Laserpoint((float)C.get(0,0),(float)C.get(1,0),(float)C.get(2,0)));*/
      
      lframe.lsegment[i].setAnchor(lerp(lframe.lsegment[i].lpoint[0].x,lframe.lsegment[i].lpoint[1].x,noise(noiseloc)),
                                   lerp(lframe.lsegment[i].lpoint[0].y,lframe.lsegment[i].lpoint[1].y,noise(noiseloc)),0);
      lframe.lsegment[i].rotZ(0.1);
    }
    noiseloc+=0.005;
    return lframe;
  }
}

class vanBlinds implements Lasershape {
  Laserframe lframe;
  float phase = 0;
  float barradius;
  float pi_slice;
  vanBlinds() {
    lframe = new Laserframe();
    barradius = 500.0/24.0;
    pi_slice = TWO_PI/12.0;
    float phase;
    for (int i = 0; i < 12; i++) {
      Lasersegment polyseg = new Lasersegment();
      Laserpoint[] j = {new Laserpoint(-barradius,0,0,1,1,1),new Laserpoint(barradius,0,0,1,1,1)};
      polyseg.addLpoint(j);
      lframe.addLsegment(polyseg);
      lframe.lsegment[i].transLseg((2*barradius*i)-250+barradius,sin(pi_slice*i)*75,0);
      lframe.lsegment[i].setAnchor((2*barradius*i)-250+barradius,sin(pi_slice*i)*75,0);
    }
  }
  Laserframe animate() {
    for (int i = 0; i< lframe.lsegment.length; i++) {
      lframe.lsegment[i].transLseg(0,-lframe.lsegment[i].anchor.y+sin(pi_slice*i+phase)*75,0);
      //lframe.lsegment[i].setAnchor((2*barradius*i)-250+barradius,-lframe.lsegment[i].anchor.y+sin(pi_slice*i+phase)*75,0);
    }
    phase+=0.05;
    return lframe;
  }
}

