
GLUT glut = new GLUT();; 
int font = GLUT.BITMAP_HELVETICA_10;

class GLRenderer implements GLEventListener {
  GL gl;
 
  public void init(GLAutoDrawable drawable) {
    this.gl = drawable.getGL();
    gl.glClearColor(0, 0, 0, 0);
  }
 
  public void display(GLAutoDrawable drawable) {
    float text_vpos = 0.85;
    gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
    gl.glColor3f(1, 1, 1);  
    gl.glRasterPos3f(-1, 0.95, 0);
    glut.glutBitmapString(font, "Points in frame: "+current.pointcount);
    gl.glRasterPos3f(-1,0.90, 0);
    glut.glutBitmapString(font, "Segments in frame: "+current.segmentcount);
    gl.glRasterPos3f(-1,0.85, 0);
    glut.glutBitmapString(font, "Sample Rate: "+synthContext.getFrameRate()+"Hz");
    gl.glRasterPos3f(0,0.85, 0);
    glut.glutBitmapString(font, "Latency: "+synthContext.getOutputLatency());
    gl.glRasterPos3f(-1,0.80, 0);
    glut.glutBitmapString(font, "Frame Rate: "+frameRate);
    gl.glRasterPos3f(-1,0.75, 0);
    glut.glutBitmapString(font, "Signal Buffer Util: "+int(100-(ch0Queue.available())/BUFF_SIZE)+"%");
    gl.glRasterPos3f(-1,0.70, 0);
    glut.glutBitmapString(font, "Now Reading: "+lwave.now_reading);
    gl.glRasterPos3f(-1,0.65, 0);
    glut.glutBitmapString(font, "Mouse: "+(mouseX-250)+", "+(mouseY-250));
   /* gl.glRasterPos3f(-1,0.60, 0);
    glut.glutBitmapString(font, "Now Reading: "+lwave.now_reading);*/
    gl.glRasterPos3f(-1,0.0, 0);    
    glut.glutBitmapString(font, "System Time: "+year()+"/"+month()+"/"+day()+" "+nf(hour(),2)+":"+nf(minute(),2)+":"+nf(second(),2));
  }
   
  public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
  }
 
  public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
  }
} 
